{#
/**
 * @file
 * Adds a custom branded User interface kit inheriting styles from your theme.
 *
 * Available variables:
 * - All variables inherited from page.html.twig
 * - dev_mode: Allows developers to view code on how to implement a given element. (config)
 * - glossary_defaults: Declares default sections in the sidebar.
 *  - Override by copying the page block into your own themes templates/ui-kit/page--ui-kit.html.twig
 *    and set your own glossary = {} array to redefine the existing structure.
#}
{{ attach_library('bootstrap_ui_kit/bootstrap-ui-kit') }}

{% if dev_mode %}
  {{ attach_library('bootstrap_ui_kit/bootstrap-ui-kit.highlight-js') }}
{% endif %}

{# Setup our glossary of sections. #}
{% block page %}

  {# Create default UI Kit glossary #}
  {% set glossary_defaults = {
    'foundations': {
      'color': {
        'modal': 0,
      },
      'iconography': {},
      'typography': {
        'modal': 0,
      },
    },
    'components': {
      'accordions': {},
      'alerts': {},
      'buttons_links': {
        'title': 'Buttons & Links',
      },
      'card': {
        'title': 'Cards',
      },
      'navigation': {},
    },
  } %}
  {% set glossary = glossary|default(glossary_defaults) %}

  <div class="bootstrap-ui-kit d-flex flex-column flex-lg-row align-items-stretch gap-5">

    {# Tabs #}
    <div class="bootstrap-ui-kit__sidebar col-12 col-lg-2 h-100 overflow-scroll pb-lg-5">
      <div class="nav navbar navbar-expand-lg navbar-dark nav-pills" role="tablist" aria-orientation="vertical">
        <div class="d-flex flex-column w-100 mb-auto">

          {# UI Kit logo/page title #}
          <div class="p-4">
            <div class="d-flex justify-content-between align-items-center">

              {% block logo %}
                <a href="{{ url('<front>') }}" class="text-reset">
                  {{ source('@bootstrap_ui_kit/img/logo.svg') }}
                </a>
              {% endblock %}

              {% if access is same as (true) %}
                {% block navbar_toggler %}
                  <button class="navbar-toggler"
                          type="button"
                          data-bs-toggle="collapse"
                          data-bs-target="#bootstrap-ui-kit__nav"
                          aria-controls="bootstrap-ui-kit__nav"
                          aria-expanded="false"
                          aria-label="{{ 'Toggle navigation'|t }}">
                    <span class="navbar-toggler-icon"></span>
                  </button>
                {% endblock %}
              {% endif %}

            </div>
            <p class="mt-3 fw-lighter">
              {% if access is same as (true) %}
                {{ page['#title'] }}
                {% if dev_mode %}
                  <span
                    class="badge rounded-pill bg-light text-light bg-opacity-25 fw-normal ms-1">{{ 'Dev mode'|t }}</span>
                {% endif %}
              {% else %}
                {{ 'UI Kit Library'|t }}
              {% endif %}
            </p>
          </div>

          {% if access is same as (true) %}
          <div class="collapse navbar-collapse" id="bootstrap-ui-kit__nav">
            <ul class="list-unstyled list-style-lower-roman bootstrap-ui-kit__glossary w-100 mb-auto">
              {% for key, category in glossary %}
                <li class="mb-4">

                  {# Category (Foundations, Components, etc.) #}
                  <strong class="d-block mb-3 px-4 gap-1 {{ not loop.first ? 'pt-4' }}">
                    <small aria-hidden="presentation">{% for i in range(1, loop.index) %}{{ 'i' }}{% endfor %}.
                    </small> {{ key|upper }}</strong>

                  {# Section tabs (Colour, Iconography, Cards, etc.) #}
                  {% for key, section in category %}

                    {# Button/tab vars. #}
                    {% set section = section|merge({
                      'id' : key|clean_class|replace({'--': '-'}),
                      'title' : section.title ? section.title : key|replace({'_': ' '})|capitalize,
                    }) %}

                    <button
                      class="nav-link py-2 px-4 text-start d-block w-100 rounded-0 {{ loop.parent.loop.first and loop.first ? ' active' }}"
                      id="{{ section.id }}-tab"
                      data-bs-toggle="tab"
                      data-bs-target="#{{ section.id }}"
                      type="button"
                      role="tab"
                      aria-controls="{{ section.id }}"
                      aria-selected="true">{{ section.title }}</button>
                  {% endfor %}

                </li>
              {% endfor %}
            </ul>
          </div>
          {% endif %}

        </div>
      </div>
    </div>
    {# / Tabs #}

    {# Content #}
    <div class="col-12 col-lg offset-lg-2 pt-5">
      <div class="tab-content p-5 pt-0">
        {{ page.content_top }}
        {{ page.highlighted }}
        {{ page.help }}
        {{ page.content }}

        {% if access is same as (true) %}
          {% for key, category in glossary %}
            {% for key, section in category %}

              {# IMPORTANT: Setup our section name, it gets used for our directory structure & filenames. #}
              {# Button/tab vars. #}
              {% set section = section|merge({
                'id': key|clean_class|replace({'--': '-'}),
                'title': section.title ? section.title : key|replace({'_': ' '})|capitalize,
              }) %}
              <div class="tab-pane fade {{ loop.parent.loop.first and loop.first ? 'show active' }}"
                   id="{{ section.id }}"
                   role="tabpanel"
                   aria-labelledby="{{ section.id }}-tab"
                   tabindex="0">
                {#
                # Section templates are resolved in the following order;
                # - custom path     (custom theme or module: under the /ui-kit/ dir)
                # - active theme    (under the /ui-kit/ dir)
                # - base theme      (under the /ui-kit/ dir)
                # - defaults        (bootstrap_ui_kit module)
                # - boilerplate     (how-to fallback)
                #}
                {% include  [
                  ('@' ~ section.path ~ '/ui-kit/' ~  section.id ~ '/' ~  section.id ~ '.html.twig'),
                  ('@' ~ active_theme ~ '/ui-kit/' ~  section.id ~ '/' ~  section.id ~ '.html.twig'),
                  ('@' ~ base_themes|first ~ '/ui-kit/' ~  section.id ~ '/' ~  section.id ~ '.html.twig'),
                  ('@bootstrap_ui_kit/ui-kit/' ~  section.id ~ '/' ~  section.id ~ '.html.twig'),
                  '@bootstrap_ui_kit/ui-kit/boilerplate/boilerplate.html.twig'
                  ] with { section: section, dev_mode: dev_mode } %}
              </div>
            {% endfor %}
          {% endfor %}
        {% endif %}
      </div>
    </div>
    {# / Content #}

  </div>
{% endblock %}

